This module contains only impedance matching code for GHC's foreign
objects. It is meant as a future replacement for the module Foreign.

Designed by the FFI task force,
hacked by Sven Panne <Sven.Panne@informatik.uni-muenchen.de>, Jan 2000

\begin{code}
module ForeignObj
        ( ForeignObj,        -- abstract, instance of: Eq
        , makeForeignObj     -- :: Addr -> IO () -> IO ForeignObj
        , foreignObjToAddr   -- :: ForeignObj -> Addr
        ) where
\end{code}

\begin{code}
import Addr(Addr)
import Foreign(ForeignObj, mkForeignObj, addForeignFinalizer)
import qualified Foreign(foreignObjToAddr)
import IOExts(unsafePerformIO)
\end{code}

\begin{code}
makeForeignObj :: Addr -> IO () -> IO ForeignObj
makeForeignObj addr finalizer = do
   fObj <- mkForeignObj addr
   addForeignFinalizer fObj finalizer
   return fObj

foreignObjToAddr :: ForeignObj -> Addr
foreignObjToAddr = unsafePerformIO . Foreign.foreignObjToAddr
\end{code}
